



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>spring beans源码解读之--Bean的定义及包装</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">spring beans源码解读之--Bean的定义及包装</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-12 15:24:01 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>bean的定义，包装是java bean的基础。再怎么强调它的重要性都不为过，因此深入 了解这块的代码对以后的代码研究可以起到事半功倍的功效。</p>
<p>1. Bean的定义BeanDefinition</p>
<p>1.1&nbsp;BeanDefinition 作用</p>
<p>一个BeanDefinition描述了一个bean的实例，包括属性值，构造方法参数值和继承自它的类的更多信息。BeanDefinition仅仅是一个最简单的接口，主要功能是允许BeanFactoryPostProcessor 例如PropertyPlaceHolderConfigure 能够检索并修改属性值和别的bean的元数据。</p>
<p>1.2&nbsp;BeanDefinition的继承关系</p>
<div>
<pre class="prettyprint linenums">父接口：<br />
AttributeAccessor, BeanMetadataElement<br />
子接口：<br />
AnnotatedBeanDefinition<br />
子类:<br />
AbstractBeanDefinition, AnnotatedGenericBeanDefinition, ChildBeanDefinition, GenericBeanDefinition, RootBeanDefinition, ScannedGenericBeanDefinition </pre>
</div>
<p>其中，AttributeAccessor接口定义了最基本的对任意对象的元数据的修改或者获取，主要方法有：</p>
<div>
<pre class="prettyprint linenums">String[] attributeNames()<br />
Object getAttribute(String name)<br />
boolean hasAttribute(String name)<br />
Object removeAttribute(String name)<br />
void setAttribute(String name, Object value) </pre>
</div>
<p>BeanMetadataElement接口提供了一个getResource()方法,用来传输一个可配置的源对象。</p>
<p>1.3&nbsp;BeanDefinition的抽象类AbstractBeanDefinition</p>
<div>
<pre class="prettyprint linenums">public abstract class AbstractBeanDefinition extends BeanMetadataAttributeAccessor<br />
        implements BeanDefinition, Cloneable {<br />
}</pre>
</div>
<p>其中，BeanMetadataAttributeAccessor接口既实现了BeanMetadataElement接口提供的getResource()方法也提供了AttributeAccessorSupport 针对属性的增删改查，如上AttributeAccessor的方法。</p>
<div>
<pre class="prettyprint linenums">public class BeanMetadataAttributeAccessor extends AttributeAccessorSupport implements BeanMetadataElement {<br />
}</pre>
</div>
<p>我们来看看一个抽象的beanDefinition 的创建涉及到哪些属性？</p>
<p>构造方法之一，创建一个新的默认设置的AbstractBeanDefinition，如下面代码所示，具体信息也可以参考BeanDefinitionDefaults这个类。</p>
<p>构造方法之二，根据构造参数值和属性参数值来创建。</p>
<div>
<pre class="prettyprint linenums">    /**<br />
     * Create a new AbstractBeanDefinition with default settings.<br />
     */<br />
    protected AbstractBeanDefinition() {<br />
        this(null, null);<br />
    }

    /**<br />
     * Create a new AbstractBeanDefinition with the given<br />
     * constructor argument values and property values.<br />
     */<br />
    protected AbstractBeanDefinition(ConstructorArgumentValues cargs, MutablePropertyValues pvs) {<br />
        setConstructorArgumentValues(cargs);<br />
        setPropertyValues(pvs);<br />
    }</pre>
</div>
<p>构造方法之三是深复制一个原有的beandefinition。</p>
<div>
<pre class="prettyprint linenums">/**<br />
     * Create a new AbstractBeanDefinition as a deep copy of the given<br />
     * bean definition.<br />
     * @param original the original bean definition to copy from<br />
     */<br />
    protected AbstractBeanDefinition(BeanDefinition original) {<br />
        setParentName(original.getParentName());<br />
        setBeanClassName(original.getBeanClassName());<br />
        setFactoryBeanName(original.getFactoryBeanName());<br />
        setFactoryMethodName(original.getFactoryMethodName());<br />
        setScope(original.getScope());<br />
        setAbstract(original.isAbstract());<br />
        setLazyInit(original.isLazyInit());<br />
        setRole(original.getRole());<br />
        setConstructorArgumentValues(new ConstructorArgumentValues(original.getConstructorArgumentValues()));<br />
        setPropertyValues(new MutablePropertyValues(original.getPropertyValues()));<br />
        setSource(original.getSource());<br />
        copyAttributesFrom(original);

        if (original instanceof AbstractBeanDefinition) {<br />
            AbstractBeanDefinition originalAbd = (AbstractBeanDefinition) original;<br />
            if (originalAbd.hasBeanClass()) {<br />
                setBeanClass(originalAbd.getBeanClass());<br />
            }<br />
            setAutowireMode(originalAbd.getAutowireMode());<br />
            setDependencyCheck(originalAbd.getDependencyCheck());<br />
            setDependsOn(originalAbd.getDependsOn());<br />
            setAutowireCandidate(originalAbd.isAutowireCandidate());<br />
            copyQualifiersFrom(originalAbd);<br />
            setPrimary(originalAbd.isPrimary());<br />
            setNonPublicAccessAllowed(originalAbd.isNonPublicAccessAllowed());<br />
            setLenientConstructorResolution(originalAbd.isLenientConstructorResolution());<br />
            setInitMethodName(originalAbd.getInitMethodName());<br />
            setEnforceInitMethod(originalAbd.isEnforceInitMethod());<br />
            setDestroyMethodName(originalAbd.getDestroyMethodName());<br />
            setEnforceDestroyMethod(originalAbd.isEnforceDestroyMethod());<br />
            setMethodOverrides(new MethodOverrides(originalAbd.getMethodOverrides()));<br />
            setSynthetic(originalAbd.isSynthetic());<br />
            setResource(originalAbd.getResource());<br />
        }<br />
        else {<br />
            setResourceDescription(original.getResourceDescription());<br />
        }<br />
    }</pre>
</div>
<p>上述三个方法涉及到的接口和类有：</p>
<p>ConstructorArgumentValues：构造参数，保存了构造方法所有的参数值，通常作为bean definition的一部分来使用。它不仅支持类型匹配的普通参数，也支持根据参数列表中的索引位置来提供参数。提供了两个变量来保存参数：带索引的和不带索引的</p>
<div>
<pre class="prettyprint linenums">public class ConstructorArgumentValues {

    private final Map&lt;Integer, ValueHolder&gt; indexedArgumentValues = new LinkedHashMap&lt;Integer, ValueHolder&gt;(0);

    private final List&lt;ValueHolder&gt; genericArgumentValues = new LinkedList&lt;ValueHolder&gt;();<br />
}</pre>
</div>
<p>MutablePropertyValues：PropertyValues接口的默认实现，支持对属性的简单操作，为构造方法提供深度复制和使用map获取构造的支持。</p>
<p>1.4 bean definition实现类ChildBeanDefinition, GenericBeanDefinition, RootBeanDefinition</p>
<p>　1.4.1　ChildBeanDefinition是一种bean definition，它可以继承它父类的设置，即ChildBeanDefinition对RootBeanDefinition有一定的依赖关系。</p>
<p>　　ChildBeanDefinition从父类继承构造参数值，属性值并可以重写父类的方法，同时也可以增加新的属性或者方法。(类同于java类的继承关系)。若指定初始化方法，销毁方法或者静态工厂方法，　　ChildBeanDefinition将重写相应父类的设置。depends on，autowire mode，dependency check，sigleton，lazy init 一般由子类自行设定。</p>
<p>注意：从spring 2.5 开始，提供了一个更好的注册bean definition类GenericBeanDefinition，它支持动态定义父依赖，方法是GenericBeanDefinition.setParentName(java.lang.String)，GenericBeanDefinition可以有效的替代ChildBeanDefinition的绝大分部使用场合。</p>
<p>1.4.2 GenericBeanDefinition是一站式的标准bean definition，除了具有指定类、可选的构造参数值和属性参数这些其它bean definition一样的特性外，它还具有通过parenetName属性来灵活设置parent bean definition。</p>
<p>通常，&nbsp;GenericBeanDefinition用来注册用户可见的bean definition(可见的bean definition意味着可以在该类bean definition上定义post-processor来对bean进行操作，甚至为配置parent name做扩展准备)。<code>RootBeanDefinition</code> / <code>ChildBeanDefinition用来预定义具有</code>parent/child关系的bean definition。</p>
<p>1.4.3&nbsp;RootBeanDefinition</p>
<p>一个RootBeanDefinition定义表明它是一个可合并的bean definition：即在spring beanFactory运行期间，可以返回一个特定的bean。RootBeanDefinition可以作为一个重要的通用的bean definition 视图。</p>
<p>RootBeanDefinition用来在配置阶段进行注册bean definition。然后，从spring 2.5后，编写注册bean definition有了更好的的方法：GenericBeanDefinition。GenericBeanDefinition支持动态定义父类依赖，而非硬编码作为root bean definition。</p>
<p>涉及到的类：BeanDefinitionHolder，根据名称或者别名持有beanDefinition。可以为一个内部bean 注册为placeholder。</p>
<p>BeanDefinitionHolder也可以编写一个内部bean definition的注册，如果你不关注BeanNameAware等，完全可以使用RootBeanDefinition或者ChildBeanDefinition来替代。</p>
<p>2. Bean的包装BeanWrapper</p>
<p>2.1 作用：提供对标准javabean的分析和操作方法：单个或者批量获取和设置属性值，获取属性描述符，查询属性的可读性和可写性等。支持属性的嵌套设置，深度没有限制。</p>
<p>2.2 继承关系：</p>
<div>
<pre class="prettyprint linenums">public interface BeanWrapper extends ConfigurablePropertyAccessor {<br />
}

public interface ConfigurablePropertyAccessor extends PropertyAccessor, PropertyEditorRegistry, TypeConverter {<br />
}</pre>
</div>
<p>其中，ConfigurablePropertyAccessor 接口封装了PropertyAccessor的配置方法，同时继承了PropertyEditorRegistry接口，具有了对PropertyEditor进行管理的方法。该接口的固有方法：</p>
<p>ConversionService getConversionService() 返回关联的ConversionService，如果存在的话。<br />boolean isExtractOldValueForEditor() 返回标示位。如果为true，表示当使用属性编辑器编辑一个属性的值时提取旧的属性值，如果为false，则表示不提取旧值。<br />void setConversionService(ConversionService conversionService) conversionservice是从spring3.0引入的，可以作为java bean 属性编辑器的替代功能，作用是改变属性的值。<br />void setExtractOldValueForEditor(boolean extractOldValueForEditor) 设置是否提取旧的属性值标示位，如上描述。</p>
<p>另外，ConfigurablePropertyAccessor 接口继承的方法有：</p>
<p>从PropertyAccessor继承的方法有：getPropertyType, getPropertyTypeDescriptor, getPropertyValue, isReadableProperty, isWritableProperty, setPropertyValue, setPropertyValue, setPropertyValues, setPropertyValues, setPropertyValues, setPropertyValues；</p>
<p>从PropertyEditorRegistry继承的方法有：findCustomEditor, registerCustomEditor, registerCustomEditor；</p>
<p>从TypeConverter&nbsp;继承的方法有：convertIfNecessary, convertIfNecessary, convertIfNecessary 。</p>
<p>2.3&nbsp;BeanWrapper的实现类：BeanWrapperImpl</p>
<p>BeanWrapperImpl作用：可以根据需求，将集合与数组的值转换到对应目标对象的集合和数组。自定义的属性编辑器通过属性编辑器的setValue，setAsText方法实现上述的转换功能。</p>
<p>BeanWrapperImpl 默认的PropertyEditor的实现如下：(PropertyEditorRegistrySupport.java)</p>
<div>
<pre class="prettyprint linenums">private void createDefaultEditors() {<br />
        this.defaultEditors = new HashMap&lt;Class&lt;?&gt;, PropertyEditor&gt;(64);

        // Simple editors, without parameterization capabilities.<br />
        // The JDK does not contain a default editor for any of these target types.<br />
        this.defaultEditors.put(Charset.class, new CharsetEditor());<br />
        this.defaultEditors.put(Class.class, new ClassEditor());<br />
        this.defaultEditors.put(Class[].class, new ClassArrayEditor());<br />
        this.defaultEditors.put(Currency.class, new CurrencyEditor());<br />
        this.defaultEditors.put(File.class, new FileEditor());<br />
        this.defaultEditors.put(InputStream.class, new InputStreamEditor());<br />
        this.defaultEditors.put(InputSource.class, new InputSourceEditor());<br />
        this.defaultEditors.put(Locale.class, new LocaleEditor());<br />
        this.defaultEditors.put(Pattern.class, new PatternEditor());<br />
        this.defaultEditors.put(Properties.class, new PropertiesEditor());<br />
        this.defaultEditors.put(Resource[].class, new ResourceArrayPropertyEditor());<br />
        this.defaultEditors.put(TimeZone.class, new TimeZoneEditor());<br />
        this.defaultEditors.put(URI.class, new URIEditor());<br />
        this.defaultEditors.put(URL.class, new URLEditor());<br />
        this.defaultEditors.put(UUID.class, new UUIDEditor());<br />
        if (zoneIdClass != null) {<br />
            this.defaultEditors.put(zoneIdClass, new ZoneIdEditor());<br />
        }

        // Default instances of collection editors.<br />
        // Can be overridden by registering custom instances of those as custom editors.<br />
        this.defaultEditors.put(Collection.class, new CustomCollectionEditor(Collection.class));<br />
        this.defaultEditors.put(Set.class, new CustomCollectionEditor(Set.class));<br />
        this.defaultEditors.put(SortedSet.class, new CustomCollectionEditor(SortedSet.class));<br />
        this.defaultEditors.put(List.class, new CustomCollectionEditor(List.class));<br />
        this.defaultEditors.put(SortedMap.class, new CustomMapEditor(SortedMap.class));

        // Default editors for primitive arrays.<br />
        this.defaultEditors.put(byte[].class, new ByteArrayPropertyEditor());<br />
        this.defaultEditors.put(char[].class, new CharArrayPropertyEditor());

        // The JDK does not contain a default editor for char!<br />
        this.defaultEditors.put(char.class, new CharacterEditor(false));<br />
        this.defaultEditors.put(Character.class, new CharacterEditor(true));

        // Spring's CustomBooleanEditor accepts more flag values than the JDK's default editor.<br />
        this.defaultEditors.put(boolean.class, new CustomBooleanEditor(false));<br />
        this.defaultEditors.put(Boolean.class, new CustomBooleanEditor(true));

        // The JDK does not contain default editors for number wrapper types!<br />
        // Override JDK primitive number editors with our own CustomNumberEditor.<br />
        this.defaultEditors.put(byte.class, new CustomNumberEditor(Byte.class, false));<br />
        this.defaultEditors.put(Byte.class, new CustomNumberEditor(Byte.class, true));<br />
        this.defaultEditors.put(short.class, new CustomNumberEditor(Short.class, false));<br />
        this.defaultEditors.put(Short.class, new CustomNumberEditor(Short.class, true));<br />
        this.defaultEditors.put(int.class, new CustomNumberEditor(Integer.class, false));<br />
        this.defaultEditors.put(Integer.class, new CustomNumberEditor(Integer.class, true));<br />
        this.defaultEditors.put(long.class, new CustomNumberEditor(Long.class, false));<br />
        this.defaultEditors.put(Long.class, new CustomNumberEditor(Long.class, true));<br />
        this.defaultEditors.put(float.class, new CustomNumberEditor(Float.class, false));<br />
        this.defaultEditors.put(Float.class, new CustomNumberEditor(Float.class, true));<br />
        this.defaultEditors.put(double.class, new CustomNumberEditor(Double.class, false));<br />
        this.defaultEditors.put(Double.class, new CustomNumberEditor(Double.class, true));<br />
        this.defaultEditors.put(BigDecimal.class, new CustomNumberEditor(BigDecimal.class, true));<br />
        this.defaultEditors.put(BigInteger.class, new CustomNumberEditor(BigInteger.class, true));

        // Only register config value editors if explicitly requested.<br />
        if (this.configValueEditorsActive) {<br />
            StringArrayPropertyEditor sae = new StringArrayPropertyEditor();<br />
            this.defaultEditors.put(String[].class, sae);<br />
            this.defaultEditors.put(short[].class, sae);<br />
            this.defaultEditors.put(int[].class, sae);<br />
            this.defaultEditors.put(long[].class, sae);<br />
        }<br />
    }</pre>
</div>
<p>其中涉及到很多编辑器，在此就不赘叙了，如有兴趣，可以自行查找。</p>
<p>3. 小结：</p>
<p>bean的定义，包装是java bean的基础。可以这么说，这一块是spring的基石。本文仅仅揭开spring 中java bean的面纱，希望能起到抛砖引玉的功能，以飨读者。</p>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/5qxn2kz8.html">Eclipse中JAR System library 没有怎么添加？</a>
		</li>
						<li><a href="https://www.batexi.com/a/r8mj1dp8.html">C 语言学习 第三次作业总结</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qym0rmq.html">Mac无法找到摄像头问题解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvv56joq.html">Swift  动画学习笔记</a>
		</li>
						<li><a href="https://www.batexi.com/a/8okkprl9.html">重装系统（win7）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e1mm1x9.html">使用cnpm搭建企业内部私有NPM仓库</a>
		</li>
						<li><a href="https://www.batexi.com/a/qvvedkzq.html">Android IOS WebRTC 音视频开发总结（十八）-- 手机适配</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gmxkv79.html">OC5&lowbar;NSMutableString操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gekrr08.html">分析业务模型-类图（Class Diagram）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z5kmn9.html">敏捷冲刺每日报告&mdash;&mdash;Day3</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25jmnxq.html">python实战：用70行代码写了一个山炮计算器！</a>
		</li>
						<li><a href="https://www.batexi.com/a/8m2jwp0q.html">&lbrack;20180822&rsqb;session&lowbar;cached&lowbar;cursors与子游标堆0&period;txt</a>
		</li>
						<li><a href="https://www.batexi.com/a/8zyvwmx9.html">【BZOJ5336】&lbrack;TJOI2018&rsqb;party（动态规划）</a>
		</li>
						<li><a href="https://www.batexi.com/a/95gjlwzq.html">Junit4 IDEA测试学习一</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvr00r8.html">&lbrack;jzoj&rsqb;3760&period;【BJOI2014】Euler</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pw3eez8.html">Eclipse创建第一个Spring Boot项目</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwg2od8.html">Django中CBV源码解析</a>
		</li>
						<li><a href="https://www.batexi.com/a/93w65yzq.html">研究一下Spark Hash Shuffle 和 SortShuffle 原理机制</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2pldx9.html">对于移动端 App，虚拟机注册或类似作弊行为有何应对良策？</a>
		</li>
						<li><a href="https://www.batexi.com/a/9j17j0l9.html">Git -- 使用GitHub</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9rdg5pd8.html">打饭助手之NABC</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1ym2z9.html">《用格式化&lpar;fprintf和fscanf函数&rpar;的方式读写文件》</a>
			</li>
						<li><a href="https://www.batexi.com/a/q7mz77gq.html">How To Create A Struts 2 Web Application</a>
			</li>
						<li><a href="https://www.batexi.com/a/95x0mv68.html">Day1 summary</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gme5v09.html">Boostrap栅格系统</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv1rloq.html">C&plus;&plus;之创建对象时的new与不new</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1jw5x8.html">Minimum Inversion Number&lowbar;线段树&vert;&vert;树状数组</a>
			</li>
						<li><a href="https://www.batexi.com/a/90vm4ej8.html">著名的安装制作软件InnoSetup的源码及示例源码-The installation of a well-known software s source code and sample InnoSetup source</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1o6e39.html">this的指向及应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yz76eq.html">Rest文件下载</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
